/*
#######################################################################
#     Vmsplice HotFix par Franois GOICHON pour bases-hacking.org     #
#######################################################################
*/


// ATTENTION ! FAIRE SYNC AVANT *TOUT* INSMOD || RMMOD 

//Les headers standards quand on fait du kernel module
#include <linux/kernel.h>	// On travaille dans le kernel
#include <linux/module.h>	// On fait un module
#include <linux/syscalls.h>  //Les symboles des syscalls
#include <asm/unistd.h>	// La liste des syscalls pour __NR

#include <linux/tty.h>		// Pour l'utilisationd des terminaux 
#include <linux/version.h>	// Pour LINUX_VERSION_CODE
#include <linux/sched.h>   // Besoin pour init_mm & stuff et current
#include <asm/uaccess.h>   // Pour get_user() et access_ok()

#include <asm/cacheflush.h> // Pour global_flush_tlb() , change_page_attr()
#include <asm/page.h>       // Macro virt_to_page() 
#include <linux/init.h>     // Pour KERNEL_PAGE

/*
########################
#		Infos Module     #
########################
*/ 
MODULE_LICENSE("GPL"); //Pour avoir accs complet au systme, ne pas souiller le kernel
MODULE_AUTHOR("Franois GOICHON, www.bases-hacking.org");
MODULE_DESCRIPTION("Hotfix contre l'exploit root Vmsplice");


/*
############################
#		Ecriture Terminal    #
############################
*/ 

//Pour pouvoir crire sur le terminal
void printf(char *str)
{
	struct tty_struct *tty_courant;
	 
   //Recherche du terminal pour la tche courante	 
#if ( LINUX_VERSION_CODE <= KERNEL_VERSION(2,6,5) )
	tty_courant = current->tty;
#else
	//Depuis la version 2.6.6, tty a chang de place
	tty_courant = current->signal->tty;
#endif

	// Si tty_courant est NULL, la tchee courante n'a aucun terminal associ
	if (tty_courant != NULL) {
		((tty_courant->driver)->write) (tty_courant,	//Ecrire sur le terminal
#if ( LINUX_VERSION_CODE <= KERNEL_VERSION(2,6,9) )		
					   											0,	//Depuis la mmoire kernel
#endif
					   												str, strlen(str));

		/* 
		 * "\r\n" == "\015\012"
		 */

#if ( LINUX_VERSION_CODE <= KERNEL_VERSION(2,6,9) )		
		((tty_courant->driver)->write) (tty_courant, 0, "\015\012", 2);
#else
		((tty_courant->driver)->write) (tty_courant, "\015\012", 2);
#endif

	printk(KERN_INFO "%s",str); //On duplique la sortie 

	}
}



/*
###############################
#    Rcriture du syscall    #
###############################
*/ 

/*
 * On synchronise le dchargement du module : le module ne se dchargera que qd
 * plus personne n'utilisera notre syscall
 */
 
static int synchro = 0;
  
/*  
 * La table des appels systmes n'est plus exporte
 * dans les kernels 2.6.x, pour a qu'il n'y a pas l'extern 
 * qu'on peut voir dans toutes les rfrences
 *
 * Elle sera remplie par get_sct()  
 * Static (on ne rigole pas avec la table des sycalls..)
 */ 
static void **sys_call_table = NULL;

/* 
 * On va remplacer un appel systme. On va donc garder un
 * pointeur vers le syscall original (au cas u quelqu'un l'aurait
 * modifi avant nous)
 */

asmlinkage long (*vmsplice_original) (int fd, const struct iovec __user *iov, unsigned long nr_segs, unsigned int flags);

/*
 * On redfinit le syscall
 */

//Syscall de raccordement de pages utilisateurs  un tube 
asmlinkage long notre_sys_vmsplice (int fd, const struct iovec __user *iov, unsigned long nr_segs, unsigned int flags) {

	synchro++; //printf n'est pas atomique 
	if (unlikely(!access_ok(VERIFY_READ, iov->iov_base, iov->iov_len)))
	{
		printk(KERN_ALERT "Exploit root vmsplice srement tent par %d\n",current->uid); //current pointe le contexte courant 
		synchro--;
		return -EFAULT;
	}
	
	synchro--;
	
	return vmsplice_original(fd,iov,nr_segs,flags);

}

static int get_sct (void) {
//H3r3 i5 wh47 H4ckin6 I5 411 480U7... 

	unsigned long *ptr;
	
	/*
	 * le symbole sys_call_table n'tant plus exporte, on doit 
	 * la retrouver manuellement, "the hackish way" comme qui dirait.
	 *
    * La syscall table est contenue dans le segment Kernel Data
	 * situ  la suite de Kernel Code (entre end_code et end_data donc)
	 * On le repre grce  trois appels choisis arbitrairement
	 * Ici, sys_close() puis confirmation avec sys_read() et sys_open
	 *
	 * Consulter asm/unistd.h pour plus de comprhension de l'algo et 
	 * des constantes utilises
	 *
	 * Cet algo n'est pas portable
	 */  
   
	ptr=(unsigned long *)((init_mm.end_code + 4) & 0xfffffffc);

	printf("Recherche de l'adresse de sys_call_table ...");
	printk("Dbut: 0x%p Fin: 0x%p\n",(unsigned long *)init_mm.end_code,(unsigned long *)init_mm.end_data);
	printk("Ptr: 0x%p\n",(unsigned long *)ptr);


	/* On fouille la section des données */
	while((unsigned long )ptr < (unsigned long)init_mm.end_data) {
		if ((unsigned long *)*ptr == (unsigned long *)sys_close) {

			printk (KERN_INFO " -> Appel sys_close() trouv  0x%p\n", ptr);

			if ((unsigned long *)*((ptr-__NR_close)+__NR_read) == (unsigned long *) sys_read && *((ptr-__NR_close)+__NR_open) == (unsigned long) sys_open ) {

			printk (" -> table des syscalls possible  0x%p\n", ptr-__NR_close);
			printk (" -> sys_write  0x%p\n", (unsigned long *)*(ptr-__NR_close+4));
			printk (" -> sys_fork  0x%p\n", (unsigned long *)*(ptr-__NR_close+2));

			sys_call_table = (void **) ((unsigned long *)(ptr-__NR_close));
			
			break;

			}

		}
		ptr++;
	}

	printk(KERN_INFO"sys_call_table trouve  : 0x%p\n", sys_call_table);

	if (sys_call_table == NULL) return 0;
	else return 1;

}


static int is_address_writable(unsigned long address)
//Vrifie si on peut crire  l'adresse address, retourne <= 0 en cas d'erreur, 1 sinon
{
	pgd_t *pgd = pgd_offset_k(address);
#ifdef PUD_SIZE
	pud_t *pud;
#endif
	pmd_t *pmd;
	pte_t *pte;

	if (pgd_none(*pgd))
		return -1;
#ifdef PUD_SIZE
	pud = pud_offset(pgd, address);
	if (pud_none(*pud))
		return -1;
	pmd = pmd_offset(pud, address);
#else
	pmd = pmd_offset(pgd, address);
#endif
	if (pmd_none(*pmd))
		return -1;

	if (pmd_large(*pmd))
		pte = (pte_t *)pmd;
	else
		pte = pte_offset_kernel(pmd, address);

	if (!pte || !pte_present(*pte))
		return -1;

	return pte_write(*pte) ? 1 : 0;
}


/*
#################################
#		Init/Cleanup du module    #
#################################
*/
 
//Initialisation du module - remplacement de open()
int init_module(void)
{

	//Attention - trop tard, mais peut-tre pour la prochaine fois..
	
	printf("Module dangereux : sync nécessaire avant chargement\n");
	printf("La fin du module est encore plus dangereuse ! Sync avant rmmod si votre système de fichiers vous importe...\n");

	printk(KERN_INFO "Hotfix pour l'exploit Vmsplice charg\n");

	if (!get_sct()) 
	{	//Si le remplissage de la syscall table n'a pas march
		printf("Table des appels systme introuvable. Abandon...\n");
		return 1; 
	}
	
	printf("Table des appels systme trouve\n");
 
	if (!is_address_writable((unsigned long)sys_call_table))
	{
		printk("La table des appels systme est peut-tre en read-only\n");
		change_page_attr(virt_to_page(sys_call_table), 1, PAGE_KERNEL);
		global_flush_tlb();
	}
 
   //On garde en mmoire l'ancien syscall et on le remplace


	//On pourait vrifier avant avec  ls -l /boot/vmlinuz-`uname -r` que la date du fichier < 8 Fvrier 2008
	//mais l'administrateur est cens savoir si son systme est vulnrable avant d'appliquer ce genre de patch 
	vmsplice_original = sys_call_table[__NR_vmsplice];
	sys_call_table[__NR_vmsplice] = notre_sys_vmsplice;
	
	

	printf("Dtournement des syscalls afin de surveiller le systme\n");

	return 0;
}

 
//Fin du module : on nettoie nos btises 
void cleanup_module(void)
{
	 
   printf("Retour des syscalls  la normale...\n"); 
	 
	//Retourner la table des syscalls  la normale
	if (sys_call_table[__NR_vmsplice] != notre_sys_vmsplice) {
		printf("Quelqu'un d'autre a jou avec la table des appels systme\n");
		printf("Le systme a de fortes chances de s'en retirer dans un tat instable..\n"); 
	}

	sys_call_table[__NR_vmsplice] = vmsplice_original;


	printk(KERN_INFO "En attente de synchronisation\n"); 
	while(synchro);

	printk(KERN_INFO "Hotfix pour l'exploit Vmsplice dcharg\n");	
	
}
